/* Example: pointers to structures */

#include <stdio.h>

struct cplx {
              double real;  /* real part */
              double imag;  /* imaginary part */
            };

void add(struct cplx *pa, struct cplx *pb, struct cplx *pc);


void main(void)
{
  struct cplx x = {2.5, 5.0}, y = {3.2, -1.7}, z;
  
  add(&x, &y, &z);  /* call by reference: pointers are passed */
  printf("z = %4.2f + %4.2f j\n", z.real, z.imag);
  return;
}


void add(struct cplx *pa, struct cplx *pb, struct cplx *pc)
{
  (*pc).real = (*pa).real + (*pb).real;  /* add real parts */
  (*pc).imag = (*pa).imag + (*pb).imag;  /* add imaginary parts */

  /* Or we could write  pc->real = pa->real + pb->real;
                        pc->imag = pa->imag + pb->imag;
                      
  which is a shorthand notation meaning exactly the same thing. */
  
  return;
}
